namespace Dashboard.Drawing.OpenGL
{
    /// <summary>
    /// Atomic reference counter.
    /// </summary>
    public interface IArc : IDisposable
    {
        /// <summary>
        /// The number of references to this.
        /// </summary>
        int References { get; }

        /// <summary>
        /// Increment the number of references.
        /// </summary>
        void IncrementReference();

        /// <summary>
        /// Decrement the number of references.
        /// </summary>
        /// <returns>True if this was the last reference.</returns>
        bool DecrementReference();
    }
}
