using Dashboard.Drawing;
using Dashboard.Windowing;

namespace Dashboard.Controls
{
    public class Form : Control
    {
        public IWindow Window { get; }
        public override DrawQueue DrawQueue { get; }

        public override Box2d ClientArea
        {
            get => new Box2d(0, 0, Window.ClientSize.Width, Window.ClientSize.Height);
            set { }
        }

        public Form(IWindow window)
        {
            Window = window;
            DrawQueue = (window as IDrawQueuePaintable)?.DrawQueue ?? new DrawQueue();
        }
    }
}
